function default_size()
  return 50, 1.0
end

function param1()
  return "Random", 0, 100, 5
end

function set_line( w )
  bs_polygon( 0.0, -0.05 )
  bs_polygon( 0.2, -0.05 )
  bs_polygon( 1.0, 0.0 )
  bs_polygon( 0.2, 0.05 )
  bs_polygon( 0.0, 0.05 )
  bs_polygon( -0.2, 0.05 )
  bs_polygon( -1.0, 0.0 )
  bs_polygon( -0.2, -0.05 )
  bs_polygon( 0.0, -0.05 )
  bs_polygon_mul( w, w*1.2 )
end

function main( x, y, p )

  local w = bs_width_max() * 0.25
  if w < 5 then
    w = 5
  end

  if not firstDraw then
    local distance = bs_distance( lastDrawX - x, lastDrawY - y )
    if distance < w/2 then
      return 0
    end
  end

  local r,g,b = bs_fore()
  local dx,dy = bs_dir()
  local nx,ny = bs_normal()
  local a = bs_opaque() * 255

  local i
  for i=0,6 do
    local idx = i - 3
    local m = w*3/5
    local dif = (0.5 - math.random()) * bs_param1() / 100 * 2
    set_line( w )
    bs_polygon_move( 0, -idx*m + m*dif )
    bs_polygon_rotate( bs_atan( dx, dy ) + 0 )
    bs_polygon_move( x, y )
    bs_fill( r,g,b, a )
  end

  lastDrawX = x
  lastDrawY = y
  firstDraw = false

  return 1
end

bs_setmode( 1 )
lastDrawX = 0
lastDrawY = 0
firstDraw = true
